#  Building Platform 1.2.2 (1.0) and 1.3.0 (1.1)

* Fixes platform weren't craftable even with config activated.

#  Building Platform 1.2.1 (1.1)

* Make change to be compatible with factorio 1.1(.1 and hopefully later minor release)
* API to add custom platforms now limted to 10 platforms instead of 5.
* Now use custom layer 55 to 46 instead of 15 to 10.

#  Building Platform 1.2.0

* Make change to be compatible with factorio 1.0.0
* Fix base game concrete tile not being used as a template if it exists.
* Now use stone-path instead of concrete to define the tile.
* Now require base game stone path to be present. Will not load if not present.
* Temporary removed ability to set a custom picture when defining custom platform tile
* Added ability to set the tint when defining custom platform tile.
* Platforms tile are now tinted stone path.
* Removed platform graphics and old platform graphics as they are incompatible with new tile definition.
* Removed mod option to choose platform graphic.
* Added custom invisible resource "dummy platform" if normal generation is selected in options.
* Normal platform generation now use custom vanilla like resource generation (via the dummy platform).
* Dummy platform are replaced by normal platform tile when chunk are generated.


#  Building Platform 1.1.11

* Make necessary change for Factorio 0.16
* Any platform made using API call isn't based after actual concrete anymore. Instead use a copy of the concrete declaration from Factorio 0.15.35. (Until the API is updated to reflect 0.16 change to how tile are defined.)
* Any tile made using API with an autoplace setting is set to the terrain category.
* Platforms can now be placed next to water.
* Add support for other surface than nauvis to custom platform generation. The default surface ``nauvis`` is allowed custom placement of platforms by default. ([#9](http://git.neemys.name/Neemys/building-platform/issues/9))
* Add three API functions accessible in controls.lua to building-platform's interface :
 * addSurfacesToCustomPlacementList : Add one or multiple surface to the list of allowed surface for custom platform generation.
 * removeSurfacesToCustomPlacementList : Remove one or multiple surface to the list of allowed surface for custom platform generation.
 * getCustomPlacementAllowedSurfacesList : Get the list of surfaces allowed for custom platforms generation. The list is a table in the form [surface]=>true.

# Building Platform 1.1.10

* Added expensive recipe awareness. This mod don't add expensive recipe, but they shouldn't create bug anymore.
* Added AAI Industry compatibility. Restricted by default.
* Added AAI Programmable Structures compatibility. Restricted by default.
* Added AAI Programmable Vehicles compatibility. Restricted by default. Vehicle depot has its own separate config to choose if it is restricted or not.
* Added Quarry compatibility mod. Restricted by default.
* Added the whole changelog in markdown format.
* Edited Building Platform tile recipe to only take the category from the concrete recipe if it exists and fall back to ``crafting-with-fluid`` if no concrete recipe was found.
* Edited public functions' comments to use the new comment format for auto-generating API documentation.
* Fixed blocking tile under a platform was blocking building placement. ([#5](http://git.neemys.name/Neemys/building-platform/issues/5))
* Fixed AAI Programmable Vehicles's Vehicle Deployer can become uninteractable when radars were restricted.
* Fixed Long Range Radar missing locale entries.
* Fixed long range radar and building platform tile not appearing in craft list if their template recipes were using the new recipe declaration.
* Fixed long range radar not appearing in craft list if vanilla radar was behind a technology. ([#7](http://git.neemys.name/Neemys/building-platform/issues/7))

# Building Platform v1.1.9

* Fixed picked up Factorissimo building not restricted by platform when they should be. ([#4](http://git.neemys.name/Neemys/building-platform/issues/4))
* Fixed new platform icon for recipe appear on old platform recipe.
* Added compatibility with Water Well mod, blocked by default.
* Added compatibility with Stone Water Well mod, blocked by default.
* Added compatibility with Warehousing mod, blocked by default.
* Added compatibility with Teleportation mod, blocked by default.
* Added compatibility with High Voltage mod, not blocked by default.

# Building Platform v1.1.8

* Changed how custom generation is handle. Now each custom generation is a single function which receive a x and y coordinate and return the name of the tile it want to place here or nil otherwise.
* Added "grid" custom generation. It will place square of platform with a config defined side length spaced by a config defined number of tile vertically and horizontally. Those config can be changed using ingame menu.
* Ordered ingame config as follow : crafting, misc, unrestrict, generation, mods.
* Compatible mods are now detected during loading screen and only detected mods rules will be applied.
* Mods config moved to ingame menu. Only detected (and active) mods will have their option listed.
* Dropped Factorissimo (the first) compatibility as it has been discontinued by the author in favor of Factorissimo2.
* Prefix for element added to the game use constistently the constant instead of hardcodded one.

# Building Platform v1.1.7

* Added full French localization. I will maintain this one personally alongside the English one.
* Fixed placement of entity with no collision_mask set crash the game ([#2](http://git.neemys.name/Neemys/building-platform/issues/2))
* Added possibility to set aliases for a particlar platform in addPlatform function. All tile that are aliases of a platform allow buildings that platform allow.
* Added Factorissimo2 compatibility. All three factory, bulk pipes, circuit Input and output and the requester chest are affected by unrestrictMod.factorissimo2 config option. All blocked outside platform by default.
* Added a config option to make factorissimo2 factory floor act as platform (factorissimo2FactoryAsPlatform). By default they act as platform. ([#3](http://git.neemys.name/Neemys/building-platform/issues/3))
* Edited copyright mention to include 2017 year and no longer have ShadowTheAge name. He is still present in CREDITS.txt.
* Transfered long range radar from building platform tweaks mod. Will only be active in this mod if the config for it is enabled __and__ building platform tweaks mod is not active.
* Moved all config option to the new ingame menu for mods. The following config hasn't been moved yet :
 * All mod blocking config (unrestrictMod entry in config.lua). Integrating them will make the option menu unnecessarily cluttered. They will be added in a later release.
 * disableOwnPlatform: this config is not for users, but for other mod to interact with mine. No need to add it ingame.
 * factorissimo2FactoryAsPlatform: As it's a mod specific config, it will be added alongside other mods specific config in a later release.

# Building Platform v1.1.6

* Added ability to block tile placement on platform under the "buildingplatform.config.blockTileOnPlatform" config option. The same gap as between water and tiles will be present. It is a game restriction that I cannot change without making tile replace water. If you want the gap to disappear, use water-fix mod.
* Reduced the number of platform the addPlatform function can add to 4 from 5 as the fifth collision mask is now used to block tile placement on platform.
* Fixed building not blocked on any minable tile that have no ground under it.
* Steam-turbine blocking rule moved from reactors.lua file to vanilla.lua as it is now a vanilla entity. It is blocked by default (unblock it with unrestrictPower config).
* Heat exchanger is blocked by platform by default. Unblock it with unrestrictPower or unrestrictBoiler config.
* Nuclear reactor is blocked by platform by default. Unblock it with unrestrictPower config.
* Centrifuge is blocked by platform by default. Unblock it with unrestrictAssemblingMachine config.

# Building Platform v1.0.6

* Added ability to block tile placement on platform under the "buildingplatform.config.blockTileOnPlatform" config option. The same gap as between water and tiles will be present. It is a game restriction that I cannot change without making tile replace water. If you want the gap to disappear, use water-fix mod.
* Reduced the number of platform the addPlatform function can add to 4 from 5 as the fifth collision mask is now used to block tile placement on platform.
* Fixed building not blocked on any minable tile that have no ground under it.

# Building Platform v1.0.5

* Added a new (optional) generation named "Concentric Circle" made by m2cengine. Not activated by default, it can be done by editing the config entry "buildingplatform.config.platformGenerator" to "concentric-circle". This generation uses a custom function to spawn two platform. The usual blocking platform in concentric circle shape with a big patch at the spawn. A speed platform will also spawn (pale yellow concrete). For building placement this speed platform act as a ground, but provide a huge boost to speed if activated in config. The shape/size is not tweakable using new world option.
* Added a config to choose which generation for the platform you want (buildingplatform.config.platformGenerator). Vanilla placement by default.
* Added a config to reduce the overall speed of the player by 35% (buildingplatform.config.speedPenalty). Only taken into account if the generation is "concentric circle". Speed reduced by default.
* Added a config to boost the speed bonus of all tile that already have a bonus greater than the ground by 45% (buildingplatform.config.tilesSpeedBonus). Only taken into account if the generation is "concentric circle". Bonus applied by default.
* Added a config to boost the speed bonus of the speed platform by 150% (base speed bonus of this platform is concrete if not edited by other mod) (buildingplatform.config.speedPlatformSpeedBonus). Only taken into account if the generation is "concentric circle". Bonus applied by default.
* Added a config to disable the creation of the mod's platform (buildingplatform.config.disableOwnPlatform). Not activated (false) by default. Only usefull if you want to create your own platforms set in another mod using the mod's functions.
* Added support for Reactors mod in config 'buildingplatform.config.unrestrictMod'. Reactors's building not blocked by default as the author (Gotlag) don't want to make the necessary change to make his mod compatible with Building Platform. Beware if you try to make his building blocked, they will not be blocked on all case and Factorio's collision check can make his mod throw an error and exit to main menu.
* Fixed Reactors mod's reactor controller be drawn under the boiler if either furnaces or generators were configured to be blocked by a platform.
* Added more comment to explain to those reading my mod's code how things work.
* Added a new public function, accessible after my mod data.lua phase to create new platform. This function is callable using the name 'buildingplatform.addPlatform'. With a call to this function you can tell my mod to create a platform tile, tell the game how it should place it if you want to use the game world generation and edit the tile's property. It return an object that can be use to add blocking rules. Unfortunately any mod that want to add a platform with a custom placement function should do the placement itself (you can't give this function the placement function). If your platform need an item/recipe to be placeable, you need to create them yourself too. Only 5 platforms can be added by this function (included this mod's own platform). Different platforms will not make each other buildings's footprint red, but a script will still check if a building is correctly placed. For the moment only building not listed by at least one platform will be placeable on ground.
* Added a public function accessible after data.lua phase (buildingplatform.addTileToDefaultInitialization). Take one parameter, the object returned by addPlatform function and return nothing. When called, it make the mod adding all default blocking and mod compatibility to the provided platform. Can be called multiple time for multiple platform.
* Added a public function accessible after data.lua phase (buildingplatform.disableDefaultPlatform). Take no parameter and return nothing. When called it makes the mod not initializing its own platforms (they will never be added to the game's data) and deactivate any platform placement function if one was selected in the config. You can still add your own using addPlatform function.
* Edited blockAll, blockAllBut and blockOnly functions to take one more parameter than before, a tileObject returned by addPlatform function. It will apply the rule to this specific platform. If not provided, the rule will apply to all platform added to default initialization. It's backward compatible if you used it to add rules to the default platform.
* Moved constants 'buildingplatform.modRoot' and 'buildingplatform.tileName' to respectively 'buildingplatform.constants.modRoot' and 'buildingplatform.constants.tileName'
* Added two new constants : 'buildingplatform.constants.speedTileName' which hold the speed-platform name and 'buildingplatform.constants.dummyPrefix' which hold the prefix for the dummy objects name.
* The mod should now consistently use 'buildingplatform.constants.tileName' constant as the default platform's tile, recipe and item name instead of a string in each file. I recommend other mod to do the same if they use my platform's tile, recipe and item name.
* Removed leftover logs in data-final-fixes.lua.
* Added a 'private' function to handle more easily other mods compatibility and blocking config. This function shouldn't be used by other mods unless they want to edit their mod again in a future release as I don't intend to make it backward compatible with the actual version.
* Edited control.lua placement checks to add the possibility for other mod to call it through an interface.

# Building Platform v1.0.4

* Fixed a misplaced condition that made multiple blockAllBut rules on a same building type not working in certain case.
* Added a config to block/unblock building by mod (buildingplatform.config.unrestrictMod). Only existing for mod that I have set rules for already.
* Edited Alert Combinator blocking rule to be blocked only if using the new buildingplatform.config.unrestrictMod config instead of using the buildingplatform.config.unrestrictCombinator. Alert Combinator not restricted by default.
* Added block rules for Factorissimo mod's buildings. Blocked by default they can be unblocked by setting the right boolean in buildingplatform.config.unrestrictMod to true.
* Added block rules for Flow Control mod's buildings and Flow Control for Bobs pipes's buildings. Not blocked by default they can be blocked by setting the right boolean in buildingplatform.config.unrestrictMod to false.
* Added block rules for Circuit Network Switch mod's building. Not blocked by default they can be blocked by setting the right boolean in buildingplatform.config.unrestrictMod to false.

# Building Platform v1.0.3

* Added new Building Platform texture made by [Earendel](https://mods.factorio.com/mods/Earendel) and sligthly edited for the mod. It's not the final texture, but it's better than white concrete. Minimap color hasn't change, I kept the old color to make them distinguishable.
* Added new config entry to replace the new texture by the old one: oldTexture.
* Removed ShadowTheAge name in author list in the mod as he shouldn't be contacted if a problem occurs.
* Added a credits file with a line for ShadowTheAge idea and Earendel's texture.
* Added a key sequence to reload building platform recipe. Should be use if you activate the recipe midgame. The key sequence is "CTRL + ALT + K" by default but you can change it in controls options. It does not deactivate achievement. It will check requirement for the recipe for each force and only give it to the one that should have it. Should be compatible with other mods that move the recipe in another technology.

# Building Platform v1.0.2

* Fixed building not being blocked on any tile outside platforms ([Factorio forum post #215529](https://forums.factorio.com/viewtopic.php?p=215529#p215529)).
* Fixed checking area for placing building was offset by one on negative position (was a temporary fix for a bug ([Factorio forum topic #31092](https://forums.factorio.com/31092))).

# Building Platform v1.0.1

* Alert combinators from the Alert Combinator mod are now properly blocked.
* High tier Labs from Science Cost Tweaker mod are now properly blocked.

# Building Platform v1.0.0

* Removed oil barreling machine.
* Removed water and lubricant barrels recipes and items.
* Fix platform tile not created if vanilla concrete was removed by another mod. Platform tile is still based on concrete if it exists.
* Added base game dependency in info.json so it is not loaded on unsupported factorio version.
* Reworked how the mod represent restriction rules. If you made a mod that edit/use them, you need to update your mod.
* Add public functions to add custom rules for building placement.
* Added the following configs:
 * unrestrictBoiler :  to make boilers placeable outside platform when other power related building are still restricted. Restricted by default.
 * unrestrictRoboport : to make roboports placeable outside platform. Not restricted by default.
 * unrestrictSubstation : to make substations placeable outside platform. Restricted by default.
 * unrestrictFurnace : to make furnaces placeable outside platform. Restricted by default.
 * unrestrictAssemblingMachine : to make assembling machines placeable outside platform. Restricted by default.
 * unrestrictLab : to make labs placeable outside platform. Restricted by default.
 * unrestrictBeacon : to make beacons placeable outside platform. Restricted by default.
 * unrestrictRocketSilo : to make Rocket Silos placeable outside platform. Restricted by default.
* Edited unrestrictLogistic config to only unrestrict logistics chest. Not restricted by default.

# Building Platform v0.2.0

* Updated to work on Factorio 0.14.

# Building Platform v0.1.2

* Added ability to build on tile that are over platforms. No need to remove them anymore !
* Added internal capability to unrestrict buildings per pattern in case some other mod need it to unrestrict some building.
* Added oil barreling machine, placeable anywhere on map, 2x2, can only fill and empty oil from barrel. Crafting speed of 1, unlocked with automation 2 (or from the beginning if the technology is not found). The actual graphics is a glitchy placeholder, don't look at it too closely. This building is activated by default, you can deactivate it in the config file.
* Added new barreling capability. Normal assembling machine can now fill and empty barrel with water and lubricant. Beware feeding steam engine require lots of barrel. The recipe for lubricant barrel is the same as oil barrel. However, I changed speed and capacity of barrel for water. You can feed 10 steam engine with one assembly 3 if you let pipe fill with water before. Those new recipe are active by default and unlocked with fluid handling (again, if the tech doesn't exist it is unlocked from the start).
* Changed some config:
 * Logistic chest and roboport are now unrestricted by default, if you want to keep them restricted, change the "unrestrictLogistic" to false.
 * Storage tank can be unrestricted by changing "unrestrictStorageTank" to true (still restricted by default).
 * New barrel recipe can be toggled on or off with "moreBarrelRecipe" (on by default).
 * New barrelling machine can be toggled on or off with "oilBarrelingBuilding" (on by default).

# Building Platform v0.1.1

* Changed collision layer used by the building platform as the one used before was renamed in 0.13.14.

# Building Platform v0.1.0

* Re-implemented visual interdiction to place building using newly added collision-layer. When you try to place a restricted building on the ground, it footprint should be red.

# Building Platform v0.0.4

* Removed leading zero on last number in mod version.
* Code cleanup.

# Building Platform v0.0.03

* Fixed placement check script not taking direction into account when placing rotatable entity.

# Building Platform v0.0.02

* Slightly changed platform spawning in starting area. They should be a bit larger and the area should contain more patch.
* Added more config option to control which building will be restricted (all still restricted by default):
 * unrestrictPower : make boiler, solar panel, steam engine and accumulator placeable outside platform.
 * unrestrictCombinator : make combinator placeable outside platform.
 * unrestrictLogistic: make roboport and logistic chests placeable outside platform.
 * unrestrictRadar: make radar placeable outside platform.
* Removed some debug line I forget at release.
* Removed code that make building footprint on placement red outside platforms as it is interacting badly with game mechanics.

# Building Platform v0.0.01

Initial Release
