--[[
Copyright (C) 2016-2017  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]



if not buildingplatform then buildingplatform = {} end

local bpPrefix = "bp-"

buildingplatform.constants =  {
	modRoot = "__building-platform__", --root for filenames
	tileName = "building-platform", --default platform tilename, any change to the value need to be transmitted to localization files.
	speedTileName = bpPrefix.."speed-platform", --default speed platform tile name, any change to the value need to be transmitted to localization files.
	dummyPrefix = "bpdummy-", --prefix used for the dummy entity to pass information to control.lua
	radarRecipeName = bpPrefix.."radar",
	radarName = bpPrefix.."radar",
	prefix = bpPrefix, --prefix used to avoid collision with other mods
	--constant for settings, any change to the value of any of them need to be transmitted to localization files.
	craftableSetting = bpPrefix.."craftable",
	platformGeneratorSetting = bpPrefix.."platform-generator",
	speedPenaltySetting = bpPrefix.."speed-penalty",
	tilesSpeedBonusSetting = bpPrefix.."tiles-speed-bonus",
	speedPlatformSpeedBonusSetting = bpPrefix.."speed-platform-speed-bonus",
	spacingBetweenPlatformSetting = bpPrefix.."spacing-between-platform",
	sideLengthSetting = bpPrefix.."side-length",
	recipeSetting = bpPrefix.."recipe",
	unrestrictPowerSetting = bpPrefix.."unrestrict-power",
	unrestrictBoilerSetting = bpPrefix.."unrestrict-boiler",
	unrestrictCombinatorSetting = bpPrefix.."unrestrict-combinator",
	unrestrictRoboportSetting = bpPrefix.."unrestrict-roboport",
	unrestrictLogisticSetting = bpPrefix.."unrestrict-logistic",
	unrestrictStorageTankSetting = bpPrefix.."unrestrict-storageTank",
	unrestrictRadarSetting = bpPrefix.."unrestrict-radar",
	unrestrictSubstationSetting = bpPrefix.."unrestrict-substation",
	unrestrictFurnaceSetting = bpPrefix.."unrestrict-furnace",
	unrestrictAssemblingMachineSetting = bpPrefix.."unrestrict-assembling-machine",
	unrestrictLabSetting = bpPrefix.."unrestrict-lab",
	unrestrictBeaconSetting = bpPrefix.."unrestrict-beacon",
	unrestrictRocketSiloSetting = bpPrefix.."unrestrict-rocket-silo",
	oldTextureSetting = bpPrefix.."old-texture",
	blockTileOnPlatformSetting = bpPrefix.."block-tile-on-platform",
	addLongRangeRadarSetting = bpPrefix.."add-long-range-radar",
	factorissimo2FactoryAsPlatformSetting = bpPrefix.."factorissimo2-factory-as-platform",
	aaiProgrammableVehiclesUnrestrictDepotSetting = bpPrefix.."aai-programmable-vehicles-unrestrict-depot",
	modIdToName = {
		flowControl = "Flow Control",
		alertCombinator = "AlertCombinator",
		reactors = "Reactors",
		circuitNetworkSwitch = "circuit-network-switch",
		factorissimo2 = "Factorissimo2",
		highVoltage = "highvoltage",
		warehousing = "Warehousing v15",
		teleportation = "Teleportation",
		stoneWaterWell = "StoneWaterWell",
		waterWell = "WaterWell",
		aaiIndustry = "aai-industry",
		aaiProgrammableStructures = "aai-programmable-structures",
		aaiProgrammableVehicles = "aai-programmable-vehicles",
		quarry = "quarry"
	},
	modIdToHyphenName = {
		flowControl = "flow-control",
		alertCombinator = "alert-combinator",
		reactors = "reactors",
		circuitNetworkSwitch = "circuit-network-switch",
		factorissimo2 = "factorissimo2",
		highVoltage = "high-voltage",
		warehousing = "warehousing",
		teleportation = "teleportation",
		stoneWaterWell = "stone-water-well",
		waterWell = "water-well",
		aaiIndustry = "aai-industry",
		aaiProgrammableStructures = "aai-programmable-structures",
		aaiProgrammableVehicles = "aai-programmable-vehicles",
		quarry = "quarry"
	},
	dummyPlatformName = "bp-dummy-platform" --default dummy platform resource name and autoplace-control, any change to the value need to be transmitted to localization files.
}
