--[[
Copyright (C) 2016-2017  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

require("prototypes.platform") --define our own platform
require("prototypes.speed-platform") --a platform to make player go faster, only use by some generation
require("prototypes.tiles") -- add all platform tile to the game
require("prototypes.recipes") --add the default platform recipe if requested by the user
require("prototypes.radar") -- Long range radar



--We add all autoplace control and noise layer for the platforms that need it (if they want to be place by the game instead of a custom generation)
local noiseLayers={}
local autoplaceControls={}

for _,platformDefinition in pairs(buildingplatform.tiles) do
	if platformDefinition.needToInitAutoplace then
		table.insert(noiseLayers,{
			type = "noise-layer",
			name = platformDefinition.name
		})
		table.insert(autoplaceControls,{
			type = "autoplace-control",
			name = platformDefinition.autoplaceObject.control,
			richness = false, 
			order = platformDefinition.autoplaceOrder,
			category = "terrain"
		})
	end
end
if(#noiseLayers ~= 0) then
	data:extend(noiseLayers)
	data:extend(autoplaceControls)
end



--[[ map string to compare while tweaking
>>>AAANAAoABgADAwcAAAARAAAAYnVpbGRpbmctcGxhdGZvcm0DAwAE
AAAAY29hbAMDAwoAAABjb3BwZXItb3JlAwMDCQAAAGNydWRlLW9pbAM
DAwoAAABlbmVteS1iYXNlAwADCAAAAGlyb24tb3JlAwMDBQAAAHN0b2
5lAwMDDAkDUYCEHgCAhB4AAwApMfup<<<
]]--

