--[[
Copyright (C) 2016-2017  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

if not buildingplatform then buildingplatform = {} end
--TODO : move those functions elsewhere
buildingplatform.listOfTileForDefaultInitialization = {} --contain the list of tile object that want to have default blocking rules applied to them

--[[API_DOC
@description Add a tile object to the list of tile that should get the default rules. They will get the same rules as the default platform.

@param tileObject Table Tile object of the platform you want to add to the list of default initialization.
@after data
@before data-final-fixes
@alias add_tile_to_default_initialization
]]--
buildingplatform.addTileToDefaultInitialization = function(tileObject)
	table.insert(buildingplatform.listOfTileForDefaultInitialization,tileObject)
end
buildingplatform.add_tile_to_default_initialization = buildingplatform.addTileToDefaultInitialization -- alias
-- If called by any mod before data-updates phase, the default platform will not be initialized, only usefull if you do your own platform.
buildingplatform.disableDefaultPlatform = function()
	buildingplatform.config.disableOwnPlatform = true
end