--[[
Copyright (C) 2016-2017  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

-- block or unblock AAI programmable vehicles's entities. Other structure are added in programmable structures
if(buildingplatform.detectedMods.aaiProgrammableVehicles) then
	local modConfigValue = settings.startup[buildingplatform.constants.prefix.."aaiProgrammableVehicles"].value

	-- Scanners
	local buildingList = {{type="radar",pattern="unit%-scan"},{type="radar",pattern="unitdata%-scan"}}

	buildingplatform.modHandling(modConfigValue,settings.startup[buildingplatform.constants.unrestrictRadarSetting].value,buildingList)

	-- controllers
	buildingList = {{type="roboport",pattern="unit%-control"},{type="roboport",pattern="unitdata%-control"}}
	buildingplatform.modHandling(modConfigValue,settings.startup[buildingplatform.constants.unrestrictRoboportSetting].value,buildingList)

	--Deployer
	buildingplatform.modHandling(modConfigValue,true,{{type="container",pattern="vehicle%-deployer"}})
	-- Depot - Special config for it as it can act as "station storage" like with rails and buffer so it may need to be unlocked depending on player choice.
	buildingplatform.modHandling(settings.startup[buildingplatform.constants.aaiProgrammableVehiclesUnrestrictDepotSetting].value,true,{{type="gate",pattern="vehicle%-depot%-base"}})
	-- To keep draw order, we need to edit the chest even if it has no effect so it will still be drawn over the base.
	buildingplatform.modHandling(settings.startup[buildingplatform.constants.aaiProgrammableVehiclesUnrestrictDepotSetting].value,true,{{type="container",pattern="vehicle%-depot%-chest"}})
end
