--[[
Copyright (C) 2016-2017  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

--check for two string parameters, abort with error in case they are not string
buildingplatform.checkParameters = function( buildingType, pattern)
	assert(type(buildingType)== "string",debug.traceback("From building-platform mod, buildingType parameter must be a string, find the faulty calling mod at the top of the following stacktrace :", 3))
	assert(type(pattern)== "string",debug.traceback("From building-platform mod, pattern parameter must be a string, find the faulty calling mod at the top of the following stacktrace :", 3))
end

--check if the tile object given and return either that object or the objects that need the default initialization
buildingplatform.getTileObjectTable = function(tileObjectParameter)
	local tileObjectTable
	if(tileObjectParameter) then
		tileObjectTable = {tileObjectParameter}
	else
		tileObjectTable  = buildingplatform.listOfTileForDefaultInitialization
	end
	return tileObjectTable
end	

--[[block or unblock specific mod buildings. Not a "public" function as it will likely be edited in the next release without backward compatibility. Use it and be ready to update your mod when I update mine.
TODO : need to be reworked, don't account for all use case. 

modConfigValue : boolean, true if mods building should be allowed, false if they should be blocked.
vanillaConfigValue : boolean, the value of vanilla blocking that cover the mods buildings. True if vanilla building type is not blocked, false otherwise.
buildingList : table of object, each object should have a type and a pattern member. Type is for building type and pattern is the pattern that match the buildings names.
]]
buildingplatform.modHandling = function(modConfigValue,vanillaConfigValue,buildingList)
	local functionToExecute,shouldBeExecuted=false
	if(not modConfigValue) then
		functionToExecute = buildingplatform.blockOnly
		shouldBeExecuted = true
	else
		if (modConfigValue and not vanillaConfigValue) then
			functionToExecute = buildingplatform.blockAllBut
			shouldBeExecuted = true
		end
	end
	if(shouldBeExecuted) then
		for _,building in pairs(buildingList) do
			functionToExecute(building.type,building.pattern)
		end
	end
end



buildingplatform.config.disableOwnBlocking = false;

