--[[
Copyright (C) 2016-2017  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

-- base game resources autoplace
local resource_autoplace = require("resource-autoplace")
local noise = require("noise")
local tne = noise.to_noise_expression
if(not buildingplatform.config.disableOwnPlatform) then
	--initialize var depending on the generation choosen by the user
	local autoplaceObject,needAutoplace

	local tileColor = {
		r = (192),
		g = (192),
		b = (192)
	}
	if(settings.startup[buildingplatform.constants.platformGeneratorSetting].value == "concentric-circle" or settings.startup[buildingplatform.constants.platformGeneratorSetting].value == "grid") then
		autoplaceObject = nil
		needAutoplace = false
	else
		resource_autoplace.initialize_patch_set(buildingplatform.constants.dummyPlatformName, true)

		needAutoplace = false --using dummy resource instead
		autoplaceObject	= resource_autoplace.resource_autoplace_settings(
		{
		  name = buildingplatform.constants.dummyPlatformName,
		  order = "z",
		  base_density = 10,
		  has_starting_area_placement = true,
		  regular_rq_factor_multiplier = 2,
		  starting_rq_factor_multiplier = 4,
		  candidate_spot_count = 20
		})
		local dummyPlatformResource = table.deepcopy(data.raw.resource['iron-ore'])
		dummyPlatformResource.name = buildingplatform.constants.dummyPlatformName
		dummyPlatformResource.autoplace = autoplaceObject
		dummyPlatformResource.autoplace.control = buildingplatform.constants.dummyPlatformName
		dummyPlatformResource.map_color = tileColor
		data:extend({dummyPlatformResource})
		dummyPlatformResource.highlight = false
		dummyPlatformResource.randomize_visual_position = false
		dummyPlatformResource.map_grid = false
		dummyPlatformResource.selectable_in_game = false
		dummyPlatformResource.selection_priority = 0
		dummyPlatformResource.placeable_by = nil
		dummyPlatformResource.stage_counts = {1}
		dummyPlatformResource.stages = {
		  sheet =
		  {
			filename = buildingplatform.constants.modRoot.."/graphics/blank.png",
			priority = "low",
			width = 1,
			height = 1,
			frame_count = 1,
			variation_count = 1,
			hr_version = nil
		  }
		}
		
		local dummyPlatformAutoplaceControl = {
			name = buildingplatform.constants.dummyPlatformName,
			category = "terrain",
			richness = false,
			type = "autoplace-control",
			order = "z"
		}
		
		data:extend({dummyPlatformAutoplaceControl})
	end
	local tilefunction = function(tile) end
	local tint = {204, 161, 4,128}
	local aliases = nil
	--If factorissimo2 detected and the config has been set, add aliases to the platform
	if(buildingplatform.detectedMods.factorissimo2 and settings.startup[buildingplatform.constants.factorissimo2FactoryAsPlatformSetting].value) then
		aliases = {"factory-floor-1","factory-pattern-1","factory-floor-2","factory-pattern-2","factory-floor-3","factory-pattern-3"}
	end

	local platformObject = buildingplatform.addPlatform(buildingplatform.constants.tileName,needAutoplace,"c-a" ,nil,tileColor,tilefunction,aliases,tint)
	buildingplatform.addTileToDefaultInitialization(platformObject)
end
