--[[
Copyright (C) 2016-2017  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

-- get platform base tile object, copy concrete if possible.
local buildingPlatformTile
if(data.raw["tile"]["stone-path"]) then --copy actual concrete data if accessible
	buildingPlatformTile = table.deepcopy(data.raw["tile"]["stone-path"])
else --last concrete tile info check in version 0.15.35
	error("From building-platform mod, the base game don't have stone path tile, this mod require it for now. Another mod must be removing the tile.",2)
end



--then for all tile that need to be created, copy the base tile and edit what's needed
for _,platformDefinition in pairs(buildingplatform.tiles) do
	local tile = table.deepcopy(buildingPlatformTile)
	tile.can_be_part_of_blueprint = false

	tile.tint = platformDefinition.tint
	--tile.transition = nil
	tile.map_color = platformDefinition.mapColor
	tile.minable = nil --needed to be able to place other tile over it
	tile.autoplace = platformDefinition.autoplaceObject
	platformDefinition.tileFunction(tile)
	tile.name = platformDefinition.name --after the function, so the given function don't rename the tile as it will likely generate an error in later step
	data:extend({tile})
end
